<template>
  <svg
    width="209"
    height="208"
    viewBox="0 0 209 208"
    fill="none"
    xmlns="http://www.w3.org/2000/svg"
    class="diagram-card-piechart"
  >
    <!--
    <circle cx="104.619" cy="103.952" r="100.1" stroke="#BDE1FF" stroke-width="7.15003" />
    <path
      d="M204.719 103.952C204.719 85.4813 199.609 67.3704 189.953 51.6242C180.297 35.878 166.473 23.1105 150.01 14.7348C133.547 6.35903 115.088 2.7017 96.675 4.16756C78.2623 5.63343 60.6142 12.1653 45.6839 23.0403C30.7537 33.9153 19.1235 48.7092 12.0807 65.7849C5.03785 82.8605 2.85699 101.552 5.77947 119.79C8.70194 138.028 16.6138 155.103 28.6393 169.123C40.6649 183.143 56.3352 193.562 73.9158 199.228"
      stroke="#109CF1"
      stroke-width="7.15003"
      stroke-linecap="round"
    />
    <path
      d="M204.719 103.952C204.719 88.1553 200.981 72.5827 193.809 58.5076C186.637 44.4325 176.236 32.2545 163.457 22.9693C150.677 13.6841 135.881 7.5554 120.278 5.08422C104.676 2.61304 88.71 3.86958 73.6863 8.75108C58.6625 13.6326 45.0074 22.0005 33.8373 33.1706C22.6672 44.3406 14.2993 57.9958 9.41783 73.0195C4.53632 88.0432 3.27979 104.009 5.75097 119.611C8.22215 135.214 14.3509 150.01 23.6361 162.79"
      stroke="#F7004A"
      stroke-width="7.15003"
      stroke-linecap="round"
      stroke-linejoin="round"
    />
      d="M204.719 103.952 A204.719 103.952 0 1 1 23.6361 162.79"
    -->

    <path
      v-for="(arc, index) in arcs"
      :d="arc.path"
      :stroke="arc.color"
      :key="`arc-${index}`"
      stroke-width="7.15003"
      stroke-linecap="round"
    />
    <text x="60" y="125" class="small" fill="#F7004A" font-size="50">
      {{ arcs[1].proc }}%
    </text>
  </svg>
</template>
<script lang="ts">
import { Component, Vue, Watch, Prop } from "vue-property-decorator";
import { describeArc } from "@/utils/math";
import _ from "lodash";

@Component({
  components: {}
})
export default class PieChart extends Vue {
  @Prop({ required: true }) readonly series: any;

  get totalSeriesValue() {
    return _.sumBy(this.series, "value");
  }

  get arcs() {
    let lastAngle = 90;
    return _.map(_.sortBy(this.series, ["value"]), (item: any, index: any) => {
      let { arc, proc, angle } = this.drawArc(item.value, lastAngle);
      lastAngle = angle;
      return {
        value: item.value,
        color: item.color,
        proc: proc.toFixed(0),
        path: arc
      };
    });
  }

  drawArc(value: number, lastAngle: number) {
    let proc = (100 / this.totalSeriesValue) * value;
    value = proc * 3.6;
    value = lastAngle + value;
    return {
      arc: describeArc(100, 107, 80, lastAngle, value),
      proc: proc,
      angle: value
    };
  }
}
</script>
